﻿unit CTMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, 
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, 
  Vcl.ComCtrls, CBFunctions;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    edtFiles: TEdit;
    FileBtn: TSpeedButton;
    btnQuit: TButton;
    btnEncrypt: TButton;
    OpenDialog: TOpenDialog;
    Label4: TLabel;
    edtPwd: TEdit;
    btnDecrypt: TButton;
    ProgressBar: TProgressBar;
    procedure FileBtnClick(Sender: TObject);
    procedure btnQuitClick(Sender: TObject);
    procedure btnEncryptClick(Sender: TObject);
    procedure btnDecryptClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FSize      : int64;
    procedure ShowProgress (AAction : TFileAction; ACount : int64; ASpeedLimit : boolean);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses AesLib;

procedure TForm1.ShowProgress (AAction : TFileAction; ACount : int64; ASpeedLimit : boolean);
begin
  if ACount<0 then FSize:=abs(ACount);
  if FSize>0 then ProgressBar.Position:=round(ACount/FSize*100)
  else ProgressBar.Position:=0;
  end;

procedure TForm1.FileBtnClick(Sender: TObject);
var
  s : string;
begin
  with Opendialog do begin
    s:=edtFiles.Text;
    InitialDir:=ExtractFilePath(s);
    if Execute then begin
      edtFiles.Text:=FileName;
      edtPwd.SetFocus;
      end;
    end;
  end;

procedure TForm1.btnQuitClick(Sender: TObject);
begin
  Close;
  end;

procedure TForm1.btnEncryptClick(Sender: TObject);
var
  sSource,sDest    : TFileStream;
  s                : string;
begin
  s:= edtFiles.Text+'.enc';
  sSource:=TFileStream.Create(edtFiles.Text,fmOpenRead+fmShareDenyNone);
  sDest:=TFileStream.Create(s,fmCreate);
  Screen.Cursor:=crHourGlass;
  with TEncryption.Create(edtPwd.Text,0,defCryptBufSize) do begin
    OnProgress:=ShowProgress;
    ShowProgress(acEncrypt,-sSource.Size,false);   // Start
    if EncryptStream(sSource,sDest,false) then begin
      MessageDlg ('File encrypted to: '#13+s,mtInformation,[mbOK],0);
      edtFiles.Text:=s;
      end
    else
      MessageDlg ('Error on encrypting file!',mtError,[mbOK],0);
    Free;
    end;
  sSource.Free;
  sDest.Free;
  Screen.Cursor:=crDefault;
  end;

procedure TForm1.btnDecryptClick(Sender: TObject);
var
  sSource,sDest    : TFileStream;
  s                : string;
begin
  s:= ChangeFileExt(edtFiles.Text,'.dec');
  sSource:=TFileStream.Create(edtFiles.Text,fmOpenRead+fmShareDenyNone);
  sDest:=TFileStream.Create(s,fmCreate);
  Screen.Cursor:=crHourGlass;
   with TEncryption.Create(edtPwd.Text,0,defCryptBufSize) do begin
    OnProgress:=ShowProgress;
    ShowProgress(acDecrypt,-sSource.Size,false);   // Start
    if DecryptStream(sSource,sDest,sSource.Size,false) then
      MessageDlg ('File decrypted to: '#13+s,mtInformation,[mbOK],0)
    else begin
      MessageDlg ('Error on decrypting file!',mtError,[mbOK],0);
      edtPwd.SetFocus;
      end;
    Free;
    end;
  sSource.Free;
  sDest.Free;
  Screen.Cursor:=crDefault;
  end;

end.
